Subject: Re: Info: NAPI performance at "low" loads

From: Andrew Morton <[email-masked]>
Date: Tue, 17 Sep 2002 14:45:08 -0700

"David S. Miller" wrote:
> 
>    From: Andrew Morton <[email-masked]>
>    Date: Tue, 17 Sep 2002 14:32:09 -0700
> 
>    There is a similar background loadtester at
>    http://www.zip.com.au/~akpm/linux/#zc .
> 
>    It's fairly fancy - I wrote it for measuring networking
>    efficiency.  It doesn't seem to have any PCisms....
> 
> Thanks I'll check it out, but meanwhile I hacked up sparc
> specific assembler for manfred's code :-)
> 
>    (I measured similar regression using an ancient NAPIfied
>    3c59x a long time ago).
> 
> Well, it is due to the same problems manfred saw initially,
> namely just a crappy or buggy NAPI driver implementation. :-)

It was due to additional inl()'s and outl()'s in the driver fastpath.

Testcase was netperf Tx and Rx.  Just TCP over 100bT. AFAIK, this overhead
is intrinsic to NAPI.  Not to say that its costs outweigh its benefits,
but it's just there.

If someone wants to point me at all the bits and pieces to get a
NAPIfied 3c59x working on 2.5.current I'll retest, and generate
some instruction-level oprofiles.